package test;

import it.poliba.sisinflab.owl.owlapi.MicroReasonerFactory;

import java.io.File;

import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.IRI;
import org.semanticweb.owlapi.model.OWLClass;
import org.semanticweb.owlapi.model.OWLDataFactory;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;
import org.semanticweb.owlapi.model.OWLOntologyManager;
import org.semanticweb.owlapi.reasoner.OWLReasoner;

public class TestClassSatisfiability {
	
	static String ONTO_DIR = "./dataset/class_satisfiability/transmission.owl";
	static String CLASS_IRI = "http://purl.org/obo/owl/TRANS#TRANS_0000018";
	static OWLOntology onto = null;
	static OWLReasoner reasoner = null;
	
	public static void main(String[] args){
		
		try{
			OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
			OWLDataFactory owlDataFactory = OWLManager.getOWLDataFactory();
			File onto_path = new File(ONTO_DIR);
			//Load ontology from an input file
			OWLOntology onto = manager.loadOntologyFromOntologyDocument(onto_path); 
			//An instance of the class of which to verify the satisfiability
			OWLClass class2check = owlDataFactory.getOWLClass(IRI.create(CLASS_IRI));
			//Create the factory
			MicroReasonerFactory reasonerFactory = new MicroReasonerFactory();
			//Return an instance of OWLReasoner class that represents our Mini-ME reasoner
			reasoner = reasonerFactory.createMicroReasoner(onto);
			//The returned value is a boolean
			boolean result = reasoner.isSatisfiable(class2check);
			if(result){
				System.out.println("The class "+CLASS_IRI+" is satisfiable.");
			}else {
				System.out.println("The class "+CLASS_IRI+" is not satisfiable.");
			}
			
		}catch(OWLOntologyCreationException e){
			e.printStackTrace();
		}	
	}

}
