package test;

import it.poliba.sisinflab.owl.owlapi.MicroReasoner;
import it.poliba.sisinflab.owl.owlapi.MicroReasonerFactory;
import it.poliba.sisinflab.owl.sod.hlds.Composition;
import it.poliba.sisinflab.owl.sod.hlds.Item;

import java.io.File;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyManager;

public class TestCovering {
	
	static String ONTO_DIR = "./dataset/covering/toy.owl";
	static String DEMAND_DIR = "./dataset/covering/demand_toy.owl";
	static OWLOntology onto = null;
	static OWLOntology onto_demand = null;
	static MicroReasoner reasoner = null;
	
	public static void main(String args[]){
		OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
		File file = new File(ONTO_DIR);
		File demand = new File(DEMAND_DIR);
		
		try{
			onto = manager.loadOntologyFromOntologyDocument(file);
			//Create the factory
			MicroReasonerFactory reasonerFactory = new MicroReasonerFactory();
			//Return an instance of OWLReasoner class that represents our Mini-ME reasoner
			reasoner = reasonerFactory.createMicroReasoner(onto);
			onto_demand = manager.loadOntologyFromOntologyDocument(demand);
			Set<String> demands_name = reasoner.loadDemand(onto_demand);		
			String demandInd = null;
			Iterator<String> iter_demands = demands_name.iterator();
			while(iter_demands.hasNext()){
				demandInd = (String) iter_demands.next();
			}

			System.out.println("Compute covering...");
			Composition result = reasoner.composition(demandInd); 
			System.out.print("Set: ");
			Vector<Item> set = (Vector<Item>)result.Rc;
			for(int i=0; i<set.size(); i++){
				System.out.print(((Item)set.get(i)).name+", ");
			}
			System.out.println("");
			System.out.println("Uncovered-part: "+((Item)result.Du).description.toString());
			
		}catch(Exception e){
			e.printStackTrace();
		}
	}
}
