package test;

import it.poliba.sisinflab.owl.owlapi.MicroReasonerFactory;

import java.io.File;

import org.semanticweb.owlapi.apibinding.OWLManager;
import org.semanticweb.owlapi.model.OWLOntology;
import org.semanticweb.owlapi.model.OWLOntologyCreationException;
import org.semanticweb.owlapi.model.OWLOntologyManager;
import org.semanticweb.owlapi.reasoner.OWLReasoner;

public class TestOntologyConsistency {

	static String ONTO_DIR = "./dataset/ontology_consistency/worm_development.owl";
	static OWLOntology onto = null;
	static OWLReasoner reasoner = null;
	
    public static void main(String[] args){
		
		try{
			OWLOntologyManager manager = OWLManager.createOWLOntologyManager();
			File onto_path = new File(ONTO_DIR);
			//Load ontology from an input file
			OWLOntology onto = manager.loadOntologyFromOntologyDocument(onto_path); 
			//Create the factory
			MicroReasonerFactory reasonerFactory = new MicroReasonerFactory();
			//Return an instance of OWLReasoner class that represents our Mini-ME reasoner
			reasoner = reasonerFactory.createMicroReasoner(onto);
			//The returned value is a boolean
			boolean result = reasoner.isConsistent();
			if(result){
				System.out.println("The TBox of the ontology worm_development is consistent.");
			}else {
				System.out.println("The TBox of the ontology worm_development is not consistent.");
			}
			
		}catch(OWLOntologyCreationException e){
			e.printStackTrace();
		}	
	}
}
